#include <iostream>

using namespace std;
const long long N = 2e5 +10;
int a[N];
int main()
{
    int n,q;
    scanf("%d%d", &n, &q);
    for(int i=1;i<=n;i++)
    {
        scanf("%d", &a[i]);
    }
    for(int i=1;i<=q;i++)
    {
        int l,r;
        scanf("%d%d", &l, &r);
        int res=a[l];
        for(int j=l+1;j<=r;j++)
        {
            res&=a[j];

        }
        cout<<res<<endl;
    }
    return 0;
}